#!/usr/bin/env perl

use strict;
use warnings;

my $bounds = 4500;

my $n = shift @ARGV || 4;
my $w = shift @ARGV || (1 + rand($bounds - 1));
my $s = (3.1415 * $w * $w) / (70 + rand 25);
print STDERR "Generating $n-sided shape with edge width=$w want=$s\n";

my $tau = 3.141592*2;
my $angle = rand($tau);
my $ox = rand($bounds*2) - $bounds;
my $oy = rand($bounds*2) - $bounds;

print "$s\n";
print "$n\n";
for my $i (1 .. $n) {
    my $xx = cos($i/$n*$tau + $angle);
    my $yy = sin($i/$n*$tau + $angle);
    $xx *= abs($xx);
    $yy *= abs($xx);
    if ($xx > 0) {
        $xx += 0.01;
    } else {
        $xx -= 0.01;
    }
    if ($yy > 0) {
        $yy += 0.01;
    } else {
        $yy -= 0.01;
    }
    my $x = int($ox + $w * $xx);
    my $y = int($oy + $w * $yy);
    print "$x $y\n";
}
