#!/usr/bin/env python
from sys import exit

min_area = int(raw_input())
n = int(raw_input())

xy = map(lambda x: map(int, raw_input().split()), range(n))

# Verify monotone along X axis
evt = []
for i in range(n):
    j = (i+1) % n
    if xy[i] < xy[j]:
        evt += [[xy[i][0],-1], [xy[j][0],+1]]
    else:
        evt += [[xy[j][0],-1], [xy[i][0],+1]]
    evt += [[xy[i][0],+2], [xy[j][0],+2]]

evt = sorted(evt)
while len(evt) > 0 and evt[-1][1] == 2:
    evt = evt[:-1]

isect = 0
for i in evt:
    if i[1] == +2:
        if isect <> 2:
            print 'Wrong number of intersections:', isect,'at x =',i[0]
            exit(1)
    else:
        isect -= i[1]

# Verify winding order
area = 0.0
for i in range(n):
    j = (i+n-1) % n
    area += xy[i][1]*xy[j][0] - xy[i][0]*xy[j][1]
area /= 2.0

if area < 0.0:
    print 'Hull is in clockwise order'
    exit(1)

# TODO also check no lines intersect

# Verify area >= min_area
if area < min_area:
    print 'Area',area,'is not big enough to hold a bulkhead of size',min_area
    exit(1)
if area >= min_area * (101) - 1e-9:
    print 'Area',area,'can fit more than 100 bulkheads of size',min_area

exit(42)
