#include <algorithm>
#include <iostream>
#include <cassert>
#include <vector>
using namespace std;
typedef long long ll;

constexpr ll lots=(1ll<<45ll);

struct Edge{
  ll from;
  ll start;
  ll end;

  bool operator<(Edge const &a)const{
    if (start!=a.start) return start<a.start;
    if (end!=a.end) return end<a.end;
    if (from!=a.from) return from<a.from;
  }
};

void stricten(vector<Edge> &e){
  int a=0;
  for (int z=0; z<e.size(); z++){
    Edge i=e[z];
    assert(i.from>=0 and i.start>=0 and i.end>=0);
    while (a>0 and i.end<=e[a-1].end) --a;
    if (a==0 or i.start>e[a-1].start) e[a++]=i;
  }
  e.resize(a);
}

ll simulate(vector<Edge> const *edges,int en,ll cur_x,ll cur_t){
  while (cur_x<en){
    auto it=lower_bound(edges[cur_x].begin(),edges[cur_x].end(),Edge{-1,cur_t,-1});
    if (it==edges[cur_x].end()) return lots;
    cur_t=it->end; ++cur_x;
  }
  return cur_t;
}

int main(){
  int n,m; cin>>n>>m;
  static vector<Edge> jp[100],uk[100];
  while (m--){
    int s,t,p,q; cin>>s>>t>>p>>q; --s;
    jp[s].push_back(Edge{s,t,p});
    uk[s].push_back(Edge{s,t+q,p+q});
  }

  for (int i=n-1; i--;){
    stable_sort(jp[i].begin(),jp[i].end()); if (i) stricten(jp[i]);
    stable_sort(uk[i].begin(),uk[i].end()); stricten(uk[i]);
  }

  int res=-1;
  for (auto const &i: jp[0]){
    if (simulate(jp,n-1,1,i.end)+30*60<=simulate(uk,n-1,0,i.start)){
      res=i.start;
      break;
    }
  }
  if (~res) cout<<res<<endl;
  else cout<<"impossible"<<endl;
}
