#include <algorithm>
#include <iostream>
#include <vector>
using namespace std;
typedef long long ll;

constexpr ll lots=(1ll<<50ll);

struct Edge{
  ll from;
  ll start;
  ll end;

  bool operator<(Edge const &a)const{
    if (start!=a.start) return start<a.start;
    if (end!=a.end) return end<a.end;
    if (from!=a.from) return from<a.from;
  }
};

ll simulate(vector<Edge> const *edges,int en,int cur_x,ll cur_t){
  while (cur_x<en){
    ll best=lots;
    for (auto const &i: edges[cur_x])
      if (i.start>=cur_t)
        best=min(best,i.end);
    if (best>=lots) return lots;
    cur_t=best; ++cur_x;
  }
  return cur_t;
}

int main(){
  int n,m; cin>>n>>m;
  static vector<Edge> jp[100],uk[100];
  while (m--){
    int s,t,p,q; cin>>s>>t>>p>>q; --s;
    jp[s].push_back(Edge{s,t,p});
    uk[s].push_back(Edge{s,t+q,p+q});
  }
  sort(jp[0].begin(),jp[0].end());

int res=-1;
  for (auto const &i: jp[0]){
    if (simulate(jp,n-1,1,i.end)+30*60<=simulate(uk,n-1,0,i.start)){
      res=i.start;
      break;
    }
  }
  if (~res) cout<<res<<endl;
  else cout<<"impossible"<<endl;
}
