#include <iostream>
#include <vector>
#include <queue>
#include <tuple>
using namespace std;

// Worst case: 36 instructions (for 255)

struct State{
  int x,y,z;
  State(int x,int y,int z):x(x),y(y),z(z){}
  State(int t){
    z=t%257; t/=257; if (z==256) z=-1;
    y=t%257; t/=257; if (y==256) y=-1;
    x=t%257; t/=257; if (x==256) x=-1;
  }
  int encode(){
    int res=0;
    (res*=257)+=(~x?x:256);
    (res*=257)+=(~y?y:256);
    (res*=257)+=(~z?z:256);
    return res;
  }
  bool operator<(State const &a)const{
    return x!=a.x? x<a.x: y!=a.y? y<a.y: z<a.z;
  }
};

priority_queue<pair<int,State>> todo;
vector<tuple<uint16_t,const char*,State>> dist(257*257*257,tuple<uint16_t,const char*,State>{-1,"",State{-1,-1,-1}});
void push(State s,uint16_t d,const char* comment="",State from={-1,-1,-1}){
  if (d<get<0>(dist[s.encode()])){
    dist[s.encode()]=tuple<uint16_t,const char*,State>{d,comment,from};
    todo.push({-d,s});
  }
}

int main(){
  int want; cin>>want;

  push({-1,-1,-1},0);
  while (not todo.empty()){
    auto t=todo.top(); todo.pop();
    State s=t.second; int d=-t.first;
    if (get<0>(dist[s.encode()])!=d) continue;
    push({0,s.y,s.z},d+1,"ZE X\n",s);
    push({1,s.y,s.z},d+1,"ST X\n",s);
    push({s.x,0,s.z},d+1,"ZE Y\n",s);
    push({s.x,0,s.z},d+1,"ST Y\n",s);
    if (~s.z) push({s.z,s.y,-1},d+1,"PL X\n",s);
    if (~s.z) push({s.x,s.z,-1},d+1,"PL Y\n",s);
    if (~s.x) push({s.x,s.y,s.x},d+1,"PH X\n",s);
    if (~s.y) push({s.x,s.y,s.y},d+1,"PH Y\n",s);
    if ((~s.x) and (~s.z)) push({s.x,s.y,(s.x+s.z)%256},d+2,"PH X\nAD\n",s);
    if ((~s.y) and (~s.z)) push({s.x,s.y,(s.y+s.z)%256},d+2,"PH Y\nAD\n",s);
    if (s.x==want){
      vector<string> res(1,"DI X\n");
      while (s.x+s.y+s.z!=-3){
        res.push_back(get<1>(dist[s.encode()]));
        s=get<2>(dist[s.encode()]);
      }
      cerr<<d+1<<endl;
      for (int i=res.size(); i--;) cout<<res[i];
      return 0;
    }
  }
  cout<<"IMPOSSIBLE"<<endl;
}
