#!/usr/bin/env python2
import sys

B = int(sys.stdin.readline())
H = int(sys.stdin.readline())
(R, C) = map(int, sys.stdin.readline().split())
grid = map(lambda x: map(int, list(x)), sys.stdin.read().split())

bad = [[sum(1.0*grid[lr][lc]/(H**2 + (gr-lr)**2 + (gc-lc)**2)
            for lr in range(R) for lc in range(C)) < B-1e-9 for gc in range(C)] for gr in range(R)]

costs = [43, 11, 11]

# silly heuristic to do some pruning since Python is slow
trivial = 0
for r in range(R):
    for c in range(C):
        if r == 0 and bad[r][c] or r > 0 and bad[r-1][c] != bad[r][c]: trivial += 11
        if c == 0 and bad[r][c] or c > 0 and bad[r][c-1] != bad[r][c]: trivial += 11
        if r == R-1 and bad[r][c]: trivial += 11
        if c == C-1 and bad[r][c]: trivial += 11
        
opt = [0]+[1<<20]*((1<<C)-1)

at = 0
for r in range(R):
    for c in range(C):
        nopt = [1<<20]*(1<<C)
        for b in range(2):
            if bad[r][c] and not b: continue
            bound = b * costs[bad[r][c]] * ((r == 0) + (c == 0) + (r == R-1) + (c == C-1))
            for M in range(1<<C):
                prev = opt[M]
                if prev >= trivial: continue
                here = 0
                if c > 0 and ((M >> (c-1)) & 1) != b:
                    here += costs[bad[r][c] + bad[r][c-1]]
                if ((M >> c) & 1) != b:
                    if r > 0:
                        here += costs[bad[r][c] + bad[r-1][c]]
                    M ^= 1<<c
                nopt[M] = min(nopt[M], prev+here+bound)
        opt = nopt

print min(min(opt), trivial)
