#!/usr/bin/env python3

def dist(y1, x1, z1, y2, x2, z2):
  dy = y1 - y2
  dx = x1 - x2
  dz = z1 - z2
  return dy*dy + dx*dx + dz*dz


if __name__ == '__main__':
  B = int(input())
  H = int(input())
  R, C = map(int, input().split())
  grid = [list(map(int, input())) for _ in range(R)]
  assert all(len(row) == C for row in grid)

  lights = []
  for r, row in enumerate(grid):
    for c, col in enumerate(row):
      if col > 0:
        lights.append([r, c, col])

  light = [[0]*C for _ in range(R)]
  for i in range(R):
    for j in range(C):
      for k in lights:
        light[i][j] += k[2]/dist(i, j, 0, k[0], k[1], H)
        if light[i][j] > B:
          break
      if light[i][j] >= B:
          light[i][j] = 1
      else:
          light[i][j] = 0

  cost = 0
  for i, row in enumerate(light):
    print(row)
    for j, col in enumerate(row):
      around = 0
      for dy, dx in [(0, 1), (1, 0), (-1, 0), (0, -1)]:
        ni = i + dy
        nj = j + dx
        if ni < 0 or ni >= R:
          continue
        if nj < 0 or nj >= C:
          continue
        around += light[ni][nj]
      if col == 0:
        cost += around * 11
      elif col == 1 and around == 0:
        cost -= 11 * 4

  print(cost)



