#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <vector>
using namespace std;
typedef long long ll;

ll dp[502][502];
constexpr double lots=(1ll<<28ll);

double intersect(pair<ll,ll> a,pair<ll,ll> b){
  return (b.first-a.first)/(double)(a.second-b.second);
}

void append_line(vector<pair<ll,ll>> &lines, pair<ll,ll> l){
  // Sanity check inserted gradient is <= existing ones
  if (lines.size()>=1){
    assert(l.second<=lines.back().second);
    assert(l.second>=0);
  }
  // Remove dominated lines
  while (lines.size()>=1 and l.first<=lines.back().first){
    lines.pop_back();
  }
  // Remove marginalised lines
  while (lines.size()>=2 and
      intersect(lines[lines.size()-2],lines[lines.size()-1]) >=
      intersect(lines[lines.size()-2],l)){
    lines.pop_back();
  }
  lines.push_back(l);
}

int main(){
    ll n,distance,gondolas; cin>>n>>distance>>gondolas;
    ll modulus=distance*2;
    ll res=n*modulus;

    static ll when[501];
    for (int i=n; i--;) cin>>when[i], when[i]%=modulus;
    sort(when,when+n);

    for (int q=n; q--;){
        memset(dp,0x11,sizeof dp);

        dp[1][n-1]=0;
        for (int i=0; i<n; i++){
            dp[1][n-1]+=when[n-1]-when[i];
        }

        for (int i=1; i<=gondolas; i++){
            dp[i][n-1]=dp[1][n-1];

            int lx=0;
            vector<pair<ll,ll>> lin;
            for (int s=n,x=0; s--; x++){
                for (ll prev=lots; lx<lin.size();){
                    ll tmp=lin[lx].first + lin[lx].second*x;
                    dp[i][s]=min(dp[i][s],when[s]*(s+1)+tmp);
                    if (tmp<=prev) prev=tmp, ++lx; else break;
                }
                if (lx) --lx;
                auto line=make_pair(dp[i-1][s]-when[s]*n,when[s]);
                append_line(lin, line);
            }
        }

        for (int i=1; i<=gondolas; i++)
            for (int j=n; j--;)
                res=min(res,dp[i][j]);

        // rotate array
        {int z=when[0]; for (int i=0; i+1<n; i++) when[i]=when[i+1]; when[n-1]=z+modulus;}
    }
    cout<<res<<endl;
}
