#include <algorithm>
#include <iostream>
#include <cassert>
#include <cstring>
#include <vector>
using namespace std;
typedef long long ll;

ll dp[502][502];
constexpr ll lots=(1ll<<28ll);

pair<ll,ll> intersect(pair<ll,ll> a,pair<ll,ll> b){
  return {b.first-a.first, a.second-b.second};
}

static pair<ll,ll> lines[800];
static int linen=0;

void append_line(pair<ll,ll> l){
  // Remove dominated lines
  while (linen>=1 and l.first<=lines[linen-1].first) --linen;
  // Remove marginalised lines
  while (linen>=2){
    auto a=intersect(lines[linen-2],lines[linen-1]);
    auto b=intersect(lines[linen-2],l);
    if (a.first*b.second>=b.first*a.second) --linen; else break;
  }
  lines[linen++]=l;
}

int main(){
    ll n,distance,gondolas; cin>>n>>distance>>gondolas;
    ll modulus=distance*2;
    ll res=n*modulus;

    static ll when[501];
    for (int i=n; i--;) cin>>when[i], when[i]%=modulus;
    sort(when,when+n);

    for (int q=n; q--;){
        memset(dp,0x11,sizeof dp);

        dp[1][n-1]=0;
        for (int i=0; i<n; i++){
            dp[1][n-1]+=when[n-1]-when[i];
        }

        for (int i=1; i<=gondolas; i++){
            dp[i][n-1]=dp[1][n-1];

            int lx=0;
            for (int s=n,x=0; s--; x++){
                for (ll prev=lots; lx<linen;){
                    ll tmp=lines[lx].first + lines[lx].second*x;
                    dp[i][s]=min(dp[i][s],when[s]*(s+1)+tmp);
                    if (tmp<=prev) prev=tmp, ++lx; else break;
                }
                if (lx) --lx;
                append_line(make_pair(dp[i-1][s]-when[s]*n,when[s]));
            }
            linen=0;
        }

        for (int i=1; i<=gondolas; i++)
            for (int j=n; j--;)
                res=min(res,dp[i][j]);

        // rotate array
        {int z=when[0]; for (int i=0; i+1<n; i++) when[i]=when[i+1]; when[n-1]=z+modulus;}
    }
    cout<<res<<endl;
}
